// Do not remove the include below
#include "EspThermometer2.h"
#include "defines.h"

// #define ESP8266


#include <EEPROM.h>

#include "configuration.h"
#include "productionMode.h"
#include "configurationMode.h"



ADC_MODE(ADC_VCC);








#define CONFIG_SWITCH 4
bool configMode = false;



const uint16_t EEPROM_ADDR = 0;


uint32_t startTime = 0;


void setup() {
  startTime = millis();
#ifdef DEBUG
  Serial.begin(115200);
  Serial.println("Starting ...");
#endif

  pinMode(CONFIG_SWITCH, INPUT_PULLUP);

  EEPROM.get(EEPROM_ADDR, configBlock);

  configMode = ((LOW == digitalRead(CONFIG_SWITCH)) || (configBlock.magic != MAGIC));

  if (configMode) {
#ifdef DEBUG
  Serial.println("Configuration mode");
#endif

    setupConfiguration();
  } else {
#ifdef DEBUG
  Serial.println("Production mode");
  Serial.println();
  Serial.println();
  showConfiguration();
#endif

    setupProduction();
  }

#ifdef DEBUG
  Serial.println("Started.");
#endif
}

void loop() {
  if (configMode) {
    loopConfiguration();
  } else {
    loopProduction();
  }
}


